### Multinomial Logit model estimation

### Create the data array from the existing dataset
Data <- read.csv("C:/Users/keikaku/Desktop/nagoyauniv2.csv",header=TRUE)
## Count the number of data rows
hh <- nrow(Data)

## Set the initial values of the parameters (the number in parenthesis corresponds to the number of parameters to be estimated)
b0 <- numeric(5)

## Recall that we estimate parameters by maximizing the log-likelihood function, hence we first need to define that function

##### Define the log-likelihood function of the logit model#####

fr <- function(x) {
  ### declare the parameters###
  ## Alternative specific constants
  b1 <- x[1]
    
  ## Comute distance
    dist2 <- x[2]
  ## tripmode dummy

    ## early finish(18:30)
     ef1 <- x[3]
    ##Ζňy{݊
@@land1 <- x[4]
    ##Ζ
@@@wt <- x[5]
  ## declare the log-likelihood variable, set value to 0
  LL = 0
      ### For this choice problem, we consider the following 5 modes???
  ## S(train)
  ## oX(bus)
  ## (car)
  ## ](bike)
  ## k(walk)
  ## calculate the utility function: :introduce the desired explanatory variables in the function
                                        # time           # fare      # constant
  kaiyuu  <- exp(ef1*Data$ef+land1*Data$land+b1*matrix(1,nrow =hh,ncol=1))
  nonkaiyuu <- exp(dist2*Data$distance/10000+wt*Data$wt)

  
  ### Calculate the choice probabilities
  ## calculate the Inclusive Value (the denominator of the choice probabilities equation)
  deno <- (kaiyuu+nonkaiyuu)
  
  ## Calculate indiviudal choice probabilities
  Pkaiyuu <- kaiyuu / deno
  Pnonkaiyuu <- nonkaiyuu/deno
  ## Avoid problems stemming from choice probabilities becoming zero.選択確??????0になってしまっぁE??合に起こる問顁E??回避
  Pkaiyuu <- (Pkaiyuu!=0)*Pkaiyuu + (Pkaiyuu==0)
  Pnonkaiyuu <- (Pnonkaiyuu!=0)*Pnonkaiyuu + (Pnonkaiyuu==0)

  
  
  ## Choice results
  Ckaiyuu   <- Data$kaiyuu =="1"
  Cnonkaiyuu     <- Data$kaiyuu =="0"

    ## Calculate the Log-likelihood function
  LL <- colSums(Ckaiyuu*log(Pkaiyuu) + Cnonkaiyuu*log(Pnonkaiyuu))
  
}

##### Maximize the Log-likelihood function#####

##Parameter optimization 
res <- optim(b0,fr,method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))

## Parmeter estimation、Hessian matrix calculation 
b   <- res$par
hhh <- res$hessian

## Calculate the t-statistic
tval <- b/sqrt(-diag(solve(hhh)))

## L(0), Log-Likelihood when all parameters are 0
L0 <- fr(b0)
## LL, maximium likelihood
LL <- res$value

##### Output #####
print(res)
## L(0)
print(L0)
## LL
print(LL)
##rho-square
print((L0-LL)/L0)
## adjusted rho-square
print((L0-(LL-length(b)))/L0)
##estimated parameter values
print(b)
## t-statistic 
print(tval)

